#Simulates a train
# in :
#   currentSpeed - the current speed of the train (at t seconds)
#   force - the force applied (accelerate >0, brake < 0)
# out:
#   newSpeed - resulting speed in next time step (at t+1 seconds)
trainSpeed <- function(currentSpeed, force) {
  if(force < (-200) || force > 25){
    print("Invalid force:")
    print(force)
    
  }
  trainMass <- 120 * 1000
  rollingDrag <- 20 * 0.001 * 9.81
  airDrag <- 1.3 / 2 * 1.5 * 14 * currentSpeed ** 2
  dragForce <- rollingDrag + airDrag
  propellingForce <- force * 1000 - dragForce
  acceleration <- propellingForce / trainMass
  newSpeed <- max(0, currentSpeed + acceleration)
  return(newSpeed)
}

# Calculates the distance travelled
# in :
#   speeds - Array of speeds travelled at each time step of the simulation
# out:
#   Distance travelled during simulation
travelledDistance <-function(speeds){
  return(sum(speeds))
}

#simple test case
speeds <- c(42.8)

for (i in 1:1000) {
  speeds[i+1] = trainSpeed(speeds[i], -150)
}

plot(speeds)
print(tail(speeds))
print(travelledDistance(speeds))
